<template>
  <header class="c-header">
    <div
      class="header-main-nav"
      :class="[{ 'is-fixed': isFixed }, { 'is-hide': isHide }]"
    >
      <div class="container-fluid">
        <div class="row align-items-center">
          <div class="col-6 col-lg-2 col-logo">
            <a href="./" class="over logo">
              <img src="~/assets/images/logo.png" alt="Liquor Auction">
            </a>
          </div>
          <div class="col-6 col-btn-menu">
            <button class="btn-menu" @click="openOffcanvas">
              <span class="inner-btn">
                <span class="ic"><span /><span /><span /></span>
              </span>
            </button>
          </div>
          <div class="col-4 col-lg-10 col-nav">
            <main-nav />
          </div>
        </div>
      </div>
    </div>

    <div
      :class="[
        'header-offcanvas',
        { 'is-visible-offcanvas': isVisibleOffcanvas },
        { 'is-removing-offcanvas': isRemovingOffcanvas }
      ]"
    >
      <div class="oc-inner">
        <div class="oc-header">
          <button class="btn-close over" @click="closeOffcanvas">
            <font-awesome-icon :icon="['fas', 'times']" />
          </button>
        </div>
        <div class="oc-body">
          <main-nav />
          <user-nav />
          <categories-nav />
        </div>
      </div>
    </div>

    <div
      :class="[
        'header-offcanvas-overlay',
        { 'is-visible-offcanvas': isVisibleOffcanvas },
        { 'is-removing-offcanvas': isRemovingOffcanvas }
      ]"
      @click="closeOffcanvas"
    >
      <span class="d-none">Overlay</span>
    </div>
  </header>
</template>

<script>
import MainNav from '~/components/molecules/MainNav'
import UserNav from '~/components/molecules/UserNav'
import CategoriesNav from '~/components/molecules/CategoriesNav'

export default {
  components: {
    MainNav,
    UserNav,
    CategoriesNav
  },

  props: {
    /**
     * Fixed main nav when scroll top
     */
    scrollFixed: {
      type: Boolean,
      default: true
    }
  },

  data () {
    return {
      prevScrollY: 0,
      prevClientY: 0,
      isFixed: false,
      isHide: false,
      isVisibleOffcanvas: false,
      isRemovingOffcanvas: false
    }
  },

  mounted () {
    if (this.scrollFixed) {
      window.addEventListener('scroll', this.handleScroll)
    } else {
      window.removeEventListener('scroll', this.handleScroll)
    }
  },

  beforeDestroy () {
    window.removeEventListener('scroll', this.handleScroll)
  },

  methods: {
    /**
     * Hide navbar on scroll down
     */
    handleScroll () {
      // Chrome
      if (window.scrollY !== undefined) {
        if (window.scrollY < this.prevScrollY) {
          this.isHide = false
        } else if (window.scrollY < 0) {
          this.isHide = false
        } else {
          this.isHide = true
        }

        if (window.scrollY > 0) {
          this.isFixed = true
        } else {
          this.isFixed = false
        }

        this.prevScrollY = window.scrollY
      } else {
        // IE
        if (window.pageYOffset < this.prevScrollY) {
          this.isHide = false
        } else if (window.pageYOffset < 0) {
          this.isHide = false
        } else {
          this.isHide = true
        }

        if (window.pageYOffset > 0) {
          this.isFixed = true
        } else {
          this.isFixed = false
        }

        this.prevScrollY = window.pageYOffset
      }
    },

    /**
     * Open offcanvas menu
     */
    openOffcanvas () {
      document.documentElement.style.overflow = 'hidden'
      this.isVisibleOffcanvas = true
    },

    /**
     * Close offcanvas menu
     */
    closeOffcanvas () {
      this.isRemovingOffcanvas = true

      setTimeout(() => {
        this.isVisibleOffcanvas = this.isRemovingOffcanvas = false
        document.documentElement.style.overflow = null
      }, 200)
    }
  }
}
</script>
